;;;;;;;;;;;;;;;;;;;;;;;;;
;; Framal Controller   ;;
;;     by 	       ;;
;;  wiiqwertyuiop      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;
;;

if read1($00FFD5) == $23		; check if the rom is sa-1
	sa1rom
	!addr = $6000
	!BankB = $000000
else
	lorom
	!addr = $0000
	!BankB = $800000
endif

!FreeRam = $58		; Free ram for the controller
!FreeRam2 = $60		; Free ram for counter
!FramesTillClear = $7F	; Number of frames to wait to clear it

;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Hijack		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

org $0086C1
autoclean JML MeCode
NOP

MeCode:
LDA $15			
BEQ Clear	
LDA !FreeRam
BNE Skip
LDA !FreeRam2
BNE NoPress
LDA $15
STA !FreeRam
Skip:
LDA !FreeRam2
CMP #!FramesTillClear
BCC Ok
BRA NoPress
Clear:
STZ !FreeRam2
NoPress:
STZ !FreeRam
BRA Return
Ok:
LDA $13
AND #$03
BEQ Return
INC !FreeRam2
Return:
LDA $0DA8|!addr,x
STA $18
JML $0086C6|!BankB;

